'Reference info on http://msdn2.microsoft.com/en-us/library/xth2y6ft(VS.71).aspx
'Search at http://search.msdn.microsoft.com/search/Default.aspx?query=create+a+collection+class&brand=msdn&locale=en-us&refinement=00&lang=en-us
Imports Microsoft.VisualBasic
Public Class clDBObject
	Dim Name As String								'Contains the name of the database object
	Dim Type As ObjectType						'Contains the integr value related to the ObjectType
	Dim DDL As String									'Contains DDL for The object
	Dim NTMatched As Boolean = False		'Indicates that the object name and type matches another
	Dim ObjectID As Integer						'Primary key in sysobjects
	Dim DDLSoundex As String					'Soundex value of DDL string
	Dim DLMatched As Boolean = False	'Indicates that the DDL is matches another

	Public Enum ObjectType		'Type that classifies various objects
		ScalarFunction
		InlinedTableFunction
		StoredProcedure
		TableFunction
		Trigger
		UserTable
		View
		ExtendedStoredProcedure
		CheckConstraint
		DefaultConstraint
		ForeignKeyConstraint
		PrimaryKeyConstraint
		Rule
		ReplicationFilterStoredProcedure
		NotIdentified
	End Enum
	'Public Sub New(ByVal Name As String, ByVal Type As ObjectType)
	'	Me.Object_Name = Name
	'	Me.Object_Type = Type
	'End Sub
	Public Property Object_Name() As String
		Get
			Return Name
		End Get
		Set(ByVal value As String)
			Name = value
		End Set
	End Property

	Public WriteOnly Property SaveObjectType() As String
		Set(ByVal value As String)
			Select Case Trim(value)
				Case "FN"
					Type = ObjectType.ScalarFunction
				Case "IF"
					Type = ObjectType.InlinedTableFunction
				Case "P"
					Type = ObjectType.StoredProcedure
				Case "TF"
					Type = ObjectType.TableFunction
				Case "TR"
					Type = ObjectType.Trigger
				Case "U"
					Type = ObjectType.UserTable
				Case "V"
					Type = ObjectType.View
				Case "X"
					Type = ObjectType.ExtendedStoredProcedure
				Case "C"
					Type = ObjectType.CheckConstraint
				Case "D"
					Type = ObjectType.DefaultConstraint
				Case "F"
					Type = ObjectType.ForeignKeyConstraint
				Case "K"
					Type = ObjectType.PrimaryKeyConstraint
				Case "R"
					Type = ObjectType.Rule
				Case "RF"
					Type = ObjectType.ReplicationFilterStoredProcedure
				Case Else
					Type = ObjectType.NotIdentified
			End Select

		End Set
	End Property
	Public Property Object_Type() As Integer
		Get
			Return Type
		End Get
		Set(ByVal value As Integer)
			value = Type
		End Set
	End Property

	Public ReadOnly Property DisplayObjectType() As String
		Get
			Select Case Me.Object_Type
				Case ObjectType.ScalarFunction
					Return "Scalar Function"
				Case ObjectType.InlinedTableFunction
					Return "Inlined Table Function"
				Case ObjectType.StoredProcedure
					Return "Stored Procedure"
				Case ObjectType.TableFunction
					Return "Table Function"
				Case ObjectType.Trigger
					Return "Trigger"
				Case ObjectType.UserTable
					Return "Table"
				Case ObjectType.View
					Return "View"
				Case ObjectType.ExtendedStoredProcedure
					Return "Extended Stored Procedure"
				Case ObjectType.CheckConstraint
					Return "Check Constraint"
				Case ObjectType.DefaultConstraint
					Return "Default Constraint"
				Case ObjectType.ForeignKeyConstraint
					Return "Foreign Key Constraint"
				Case ObjectType.PrimaryKeyConstraint
					Return "Primary Key Constraint"
				Case ObjectType.Rule
					Return "Rule"
				Case ObjectType.ReplicationFilterStoredProcedure
					Return "Replication Filter Stored Procedure"
				Case Else	'ObjectType.NotIdentified & others
					Return "Not Identified"
			End Select
		End Get
	End Property
	Public Property Object_ID() As Integer
		Get
			Return ObjectID
		End Get
		Set(ByVal value As Integer)
			ObjectID = value
		End Set
	End Property
	Public Property Object_DDL() As String
		Get
			Return DDL
		End Get
		Set(ByVal value As String)
			DDL = value
		End Set
	End Property
	Public Property DDL_Soundex() As String
		Get
			Return DDLSoundex
		End Get
		Set(ByVal value As String)
			DDLSoundex = value
		End Set
	End Property
	Public Property NameTypeMatched() As Boolean
		Get
			Return NTMatched
		End Get
		Set(ByVal value As Boolean)
			NTMatched = value
		End Set
	End Property
	Public Property DDLMatched() As Boolean
		Get
			Return DLMatched
		End Get
		Set(ByVal value As Boolean)
			DLMatched = value
		End Set
	End Property
	Public Function IsDDLMatched(ByVal aDBObject As clDBObject) As Boolean
		If Me.DDL_Soundex.Substring(1, 1) = aDBObject.DDL_Soundex.Substring(1, 1) Then
			Select Case CType(Me.DDL_Soundex.Substring(1, 3), Integer) - _
			 CType(aDBObject.DDL_Soundex.Substring(1, 3), Integer)
				Case 1 - 30
					Me.DDLMatched = True
					aDBObject.DDLMatched = True
					Return True
				Case 31 - 50
					Me.DDLMatched = True
					aDBObject.DDLMatched = True
					Return True
				Case Else
					Return False
			End Select
		Else
			Return False
		End If
	End Function
	Public ReadOnly Property IsTableObject() As Boolean
		Get
			Select Case Me.Object_Type
				Case ObjectType.UserTable, ObjectType.View
					Return True
				Case Else
					Return False
			End Select
		End Get
	End Property

End Class


Public Class clDBObjects
	Inherits CollectionBase
	Dim databasename As String
	Public Sub New(ByVal DatabaseName As String)
		Me.databasename = DatabaseName
	End Sub

	Public Sub Add(ByVal aDBObject As clDBObject)
		List.Add(aDBObject)
	End Sub
	Public Sub Remove(ByVal index As Integer)
		' Check to see if there is a widget at the supplied index.
		If index > Count - 1 Or index < 0 Then
			' If no widget exists, a messagebox is shown and the operation is 
			' cancelled.
		Else
			' Invokes the RemoveAt method of the List object.
			List.RemoveAt(index)
		End If
	End Sub
	Public Property Database_Name() As String
		Get
			Return databasename
		End Get
		Set(ByVal value As String)
			databasename = value
		End Set
	End Property
	Public ReadOnly Property Item(ByVal index As Integer) As clDBObject
		Get
			' The appropriate item is retrieved from the List object and 
			' explicitly cast to the Widget type, then returned to the 
			' caller.
			Return CType(List.Item(index), clDBObject)
		End Get
	End Property
	Public ReadOnly Property MatchedIDsINClause() As String
		Get
			Dim strIDs As String = ""
			For Each aDBObject As clDBObject In Me
				If aDBObject.NameTypeMatched Then
					strIDs &= Trim(CType(aDBObject.Object_ID, String)) & "," & vbCrLf
				End If
			Next aDBObject
			If strIDs.Length > 0 Then
				Return strIDs.Substring(1, strIDs.Length - 4)
			Else
				Return strIDs
			End If
		End Get
	End Property
	Public ReadOnly Property MatchedObjectCount() As Integer
		Get
			Dim intIDCount As Integer = 0
			For Each aDBObject As clDBObject In Me
				If aDBObject.NameTypeMatched Then
					intIDCount += 1
				End If
			Next
			Return intIDCount
		End Get
	End Property

End Class

