Imports System.Data
Imports System.Data.SqlClient
Imports System.Security.Principal
Imports clSQLCompare


Partial Class _Default
	Inherits System.Web.UI.Page
	Const cstDivider As String = "-------------------------------------"
	Const REPORT_TITLE = "COPS DBMS Server Comparison Report"


	Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
		'Provide default DBMS and database names

		If Not Me.IsPostBack Then	'We are returning from another page

			If Session("DBMS") <> "" AndAlso Session("Database") <> "" Then
				Select Case Session("DatabaseCategory")
					Case "Standard"
						Me.txtStandardObject.Text = Session("DBMS") & "." & Session("Database")
						Me.txtComparisonObject.Text = Session("CompDB")
					Case "Comparison"
						Me.txtStandardObject.Text = Session("StdDB")
						Me.txtComparisonObject.Text = Session("DBMS") & "." & Session("Database")
				End Select
			Else	'Present default values
				Me.txtStandardObject.Text = "MOSTLS1SQLSRV03.NEW_PHONE"
				Me.txtComparisonObject.Text = "MOSTLS1SQLSRV04.NEW_PHONE_DEV"
			End If
		Else

			'Me.txtStandardObject.Text = "MOSTLS1SQLSRV03.NEW_PHONE"
			'Me.txtComparisonObject.Text = "MOSTLS1SQLSRV04.NEW_PHONE_DEV"


		End If

		Me.btnDetails.Visible = False
		'Try
		'	Session("DBMS").Remove()
		'	Session("Database").Remove()
		'	Session("DatabaseCategory").Remove()
		'Catch ex As Exception
		'End Try

		'Response.Write("<br> This page is running as : <b>" + WindowsIdentity.GetCurrent().Name + "</b><br>")


	End Sub
	Protected Sub form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles form1.Load
		btnExit.Attributes.Add("onclick", "window.close();")
	End Sub

	Protected Sub btnCompare_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnCompare.Click
		'Begins the compare process

		'Prepare the form for comparison by blocking user access,  
		'	hiding non-applicable controls and turning on the hourglass.
		Me.btnDetails.Visible = False

		'Call the main module
		Call SQLCompareMain(Me.txtStandardObject.Text, Me.txtComparisonObject.Text, Me.txtResult.Text, Me.txtReport.Text)

		'Format the results log in a text field if results are returned
		If Me.txtReport.Text.ToString.Length > 0 Then
			Me.btnDetails.Visible = True
			Me.btnDetails.Focus()
		End If


	End Sub
	Protected Sub btnDetails_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnDetails.Click
		Session("ReportPage") = Me.txtReport.Text
		Response.Redirect("~/ReportResults.aspx")
	End Sub
	Protected Sub btnExit_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnExit.Click
		Response.Write("<script language='javascript'> { window.close();}</script>")

	End Sub
	Protected Sub btnReset_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnReset.Click
		Me.txtStandardObject.Text = ""
		Me.txtComparisonObject.Text = ""
		Me.txtResult.Text = ""
		Me.txtReport.Text = ""
		Me.btnDetails.Visible = False
		Me.txtStandardObject.Focus()

	End Sub

	Protected Sub lblStdDB_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lblStdDB.Click
		Session("DatabaseCategory") = "Standard"
		Session("StdDB") = Me.txtStandardObject.Text
		Session("CompDB") = Me.txtComparisonObject.Text
		Response.Redirect("~/DBMSSelection.aspx")
	End Sub
	Protected Sub lblCompDB_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lblCompDB.Click
		Session("DatabaseCategory") = "Comparison"
		Session("StdDB") = Me.txtStandardObject.Text
		Session("CompDB") = Me.txtComparisonObject.Text
		Response.Redirect("~/DBMSSelection.aspx")

	End Sub

End Class
